package com.ozs.controller.upload;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ozs.common.core.domain.AjaxResult;
import com.ozs.common.utils.MinioUtils;
import com.ozs.common.utils.StringUtils;
import com.ozs.common.utils.uuid.IdUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.MsgAlarmService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@RestController
public class UploadController {

    @Value("${minio.bucketName}")
    private String bucketName;

    @Resource
    MinioUtils minioUtils;
    @Autowired
    BaseCameraManagementService baseCameraManagementService;


    @PostMapping("/putObject")
    public AjaxResult upLoadImage(@RequestParam("stream") MultipartFile stream,
                                  @RequestParam(value = "cameraCode", required = false) String cameraCode,
                                  @RequestParam(value = "size", required = false) Long size,
                                  @RequestParam(value = "contentType", required = false) String contentType,
                                  @RequestParam(value = "lineDir", required = false) Integer lineDir) throws Exception {
        if (stream.isEmpty()) {
            return AjaxResult.error("不能上传空文件哦");
        }
        //图片保存路径
        //String fileUploadPath ="/"+userId+"/image";
        String uploadFile = null;
        if (stream != null && !stream.isEmpty()) {

            String imageName = stream.getOriginalFilename();
            if (StringUtils.isNotBlank(imageName)) {
                LambdaQueryWrapper<BaseCameraManagement> wrapper = new LambdaQueryWrapper<BaseCameraManagement>();
                if (!ObjectUtils.isEmpty(cameraCode)) {
                    wrapper.eq(BaseCameraManagement::getCameraCode, cameraCode);
                }
                List<BaseCameraManagement> list = baseCameraManagementService.list(wrapper);
                BaseCameraManagement baseCameraManagement = list.get(0);
                String filename = IdUtils.fastSimpleUUID() + stream.getOriginalFilename().substring(stream.getOriginalFilename().lastIndexOf("."));
                SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
                String format1 = dateFormat1.format(new Date());
                String line = "";
                if (!ObjectUtils.isEmpty(lineDir)) {
                    line = lineDir == 1 ? "上行" : "下行";
                } else {
                    line = baseCameraManagement.getLineDir() == 1L ? "上行" : "下行";
                }
                String imgName = baseCameraManagement.getRailwayName() + "/" + line + "/" + baseCameraManagement.getInstallMile() +"/"+ format1 + "/" + filename;
                minioUtils.minIoClientUpload(stream.getInputStream(), imgName);
                uploadFile = "/" + baseCameraManagement.getRailwayName() + "/" + line + "/" + baseCameraManagement.getInstallMile() +"/"+ format1 + "/" + filename;

            }
        } else {
            return AjaxResult.error("上传功能出错");
        }
        return AjaxResult.success(uploadFile);
    }
}
